﻿#########################################
# Title: TX Hidden Emunand Backup Tool V1.1
# Author: RoyalPatch / Horaldo
# Date: 2019.10.09
# Info: Backup Hidden TX Emunand as per Farni
# Features to be added below:
# Add Restore Backup to new SD Option
# Progress Bar during Emunand Backup
#########################################


Set-ExecutionPolicy -Scope CurrentUser unrestricted


Add-Type -AssemblyName System.Windows.Forms
[Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms") | Out-Null
[System.Windows.Forms.Application]::EnableVisualStyles()

$date = Get-Date -UFormat "%Y.%m.%d"

#Defining First set of variables
$backup = New-Object System.Management.Automation.Host.ChoiceDescription 'Backup', 'Help for backup'

$options = [System.Management.Automation.Host.ChoiceDescription[]]($backup)

#Create the first dialog
$title = "TX Hidden Emunand Backup Tool"
$message = "Would you like to backup?"
$result = $host.ui.PromptForChoice($title, $message, $options, 0)

#Create second dialog
$title2 = "Pick the drive"

$disks= Get-WmiObject Win32_DiskDrive | ForEach-Object {
  $disk = $_
  $partitions = "ASSOCIATORS OF " +
                "{Win32_DiskDrive.DeviceID='$($disk.DeviceID)'} " +
                "WHERE AssocClass = Win32_DiskDriveToDiskPartition"
  Get-WmiObject -Query $partitions | ForEach-Object {
    $partition = $_
    $drives = "ASSOCIATORS OF " +
              "{Win32_DiskPartition.DeviceID='$($partition.DeviceID)'} " +
              "WHERE AssocClass = Win32_LogicalDiskToPartition"
   Get-WmiObject -Query $drives | ForEach-Object {
      New-Object -Type PSCustomObject -Property @{
        Disk        = $disk.DeviceID
        DiskSize    = $disk.Size
        DiskModel   = $disk.Model
        Partition   = $partition.Name
        RawSize     = $partition.Size
        DriveLetter = $_.DeviceID
        VolumeName  = $_.VolumeName
        Size        = $_.Size
        FreeSpace   = $_.FreeSpace
        Bustype     = $disk.InterfaceType
      }
    }
  }
}




#Create an empty array of ChoiceDescriptions
[System.Management.Automation.Host.ChoiceDescription[]] $diskoptions = @()

#Cheating a little here. Setting the help text to the Drive number
$disks | Where-Object -FilterScript {$_."Bustype" -Eq "USB"} | ForEach-Object {$friendly = ("&"+$_."DriveLetter"+ " " + $_."VolumeName"); $diskoptions +=  New-Object System.Management.Automation.Host.ChoiceDescription $friendly, $_."Disk"}
$message2 = "Select the TX Emunand drive to " + $options[$result].label + ":"
$driveresult = $host.ui.PromptForChoice($title2, $message2, $diskoptions, 0)

$physicalDriveLength = $diskoptions[$driveresult].HelpMessage.length -4
$physicaldrive = $diskoptions[$driveresult].HelpMessage.substring(4,$physicalDriveLength)
switch ($result)
{
     #if backup here
    0 {


    #Folder browser for where to save the backup
    $FolderBrowser = New-Object System.Windows.Forms.FolderBrowserDialog -Property @{ Description = 'Select save location of your TX Emunand Backup .' }

    $location = ''
    if($FolderBrowser.ShowDialog() -eq 'OK'){
            $location = $FolderBrowser.SelectedPath
    } else {exit}


    #create temporary folder
    #$parent = [System.IO.Path]::GetTempPath()
    $parent = $location
    [string] $name = [System.Guid]::NewGuid()
    $tfold =  New-Item -ItemType Directory -Path (Join-Path $parent $name)

    #Setting up the values to execute a prettier line
    $boot0 = $tfold.ToString() + '\Boot0.bin'
    $boot1 = $tfold.ToString() + '\Boot1.bin'
    $rawnand = $tfold.ToString() + '\Rawnand.bin'

    #Execute each section and put any output into variables for just incase
    $boot0res = .\secinspect.exe -backup $physicaldrive $boot0 2 8192
    $boot1res = .\secinspect.exe -backup $physicaldrive $boot1 8194 8192
    $rawnandres = .\secinspect.exe -backup $physicaldrive $rawnand 16386 61071360


[System.Windows.Forms.MessageBox]::Show($THIS, "TX Hidden Emunand has been backed up to: " + $tfold.ToString(),'Backup Complete','OK')

    #[System.Windows.Forms.MessageBox]::Show("TX Hidden Emunand has been backed up to: " + $tfold.ToString())
    }
    }